from casioplot import *
from math import pi,cos,sin,sqrt,atan
from plot import plot
from random import random, uniform

bullet = 10
holelist = []
score=0
score_sum = 0
p=1.2

def initxy():
  global xi,yi
  r = 30*random()
  theta = pi*random()
  xi = 192+r*cos(theta)
  yi = 95 + r*sin(theta)
def drawenva():
  plot.drawarc(192,95,90)
  plot.drawline(102,95,282,95)
  plot.drawline(192,5,192,185)
def drawtarget(x,y):
  plot.drawarc(x,y-50,25,-3.927,0.785)
  plot.drawarc(x,y,30)
  plot.drawarc(x,y,24)
  plot.drawarc(x,y,18)
  plot.drawarc(x,y,12)
  plot.drawarc(x,y,6)
  xp1=142.739+0.963*(x-192)+0.056*(y-95)
  yp1=95+sqrt(8100-(xp1-192)**2)
  xp2=241.261+0.963*(x-192)+0.056*(y-95)
  yp2=95+sqrt(8100-(xp2-192)**2)
  st=atan((y+90-yp1)/(x+200-xp1))-pi
  et=-atan((y+90-yp2)/(xp2-x+200))
  plot.drawarc(x+200,y+90,249.692,st,-2.630)
  plot.drawarc(x-200,y+90,249.692,-0.512,et)
  for  hole in holelist:
    set_pixel(round(xi+hole[0]),round(yi+hole[1]))
def drawloading():
  plot.drawarc(192,82.5,6.25,-3.927,0.785)
  plot.drawarc(192,95,7.5)
  plot.drawarc(192,95,6)
  plot.drawarc(192,95,4.5)
  plot.drawarc(192,95,3)
  plot.drawarc(192,95,1.5)
  xp1=179.685
  yp1=138.282
  xp2=204.315
  yp2=138.282
  plot.drawarc(242,117.5,62.423,-3.463,-2.630)
  plot.drawarc(142,117.5,62.423,-0.512,0.322)
  plot.drawline(xp1,yp1,xp2,yp2)
  plot.drawarc(288,186,15,-pi,0)
  plot.drawarc(288,166,3,0,pi)
  plot.drawline(281.5,166,281.5,172.481)
  plot.drawline(294.5,166,294.5,172.481)
  plot.drawline(281.5,166,286.5,166)
  plot.drawline(289.5,166,294.5,166)
  plot.drawline(121.013,80.544,131.406,86.544)
  plot.drawline(131.406,86.544,156.862,112)
  plot.drawline(156.862,112,240,160)
  plot.drawline(240,160,264,118.431)
  plot.drawline(121.013,80.544,135.696,55.113)
  plot.drawline(135.696,55.113,146.088,61.113)
  plot.drawline(146.088,61.113,180.862,70.431)
  plot.drawline(180.862,70.431,264,118.431)
def newv():
  global vx,vy
  vx = (192-xi+6*random())
  vy = (95-yi+6*random())
  v = 12*random()/sqrt(vx**2+vy**2)
  vx*=v
  vy*=v

initxy()
newv()

while True:
  try:
    clear_screen()
    drawtarget(xi,yi)
    drawenva()
    xi+=vx
    yi+=vy
    q=uniform(0,p)
    rou=sqrt((xi-192)**2+(yi-95)**2)
    if rou>30:
      xi=192+(xi-192)/rou*30
      yi=95+(yi-95)/rou*30
      newv()
    if q>1:
      newv()
  except KeyboardInterrupt:
    bullet -= 1
    holelist.append((192-xi,95-yi))
    score = max(0, 5-int(sqrt((xi-192)**2+(yi-95)**2)/6))
    score_sum+=score
    initxy()
    clear_screen()
    drawloading()
  if  bullet <= 0:
    break
  draw_string(0,0,"Score:"+str(score))
  draw_string(0,15,"TotalScore:"+str(score_sum))
  draw_string(0,30,"Bullet:"+str(bullet))
  show_screen()
print("Your score is ",score_sum)